//------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 100
#property indicator_buffers 2
#property indicator_color1 LimeGreen
#property indicator_color2 Red
#property indicator_width1 2
#property indicator_style2 STYLE_DOT
#property strict
//
//
//
//
//


enum prices
{
   pr_close,    // Close/Close
   pr_open,     // Open/Open
   pr_high,     // High/High
   pr_low,      // Low/Low
   pr_median,   // Median/Median
   pr_typical,  // Typical/Typical
   pr_weighted, // Weighted/Weighted
   pr_highlow   // Low/High
};
extern int    KPeriod    =14;
extern int    DPeriod    = 3;
extern int    Slowing    = 3;
extern int    MAMode     = 1;
extern prices Price      = pr_close;    
extern double Level1     = 80;
extern double Level2     = 20;

//
//
//
//
//

double MainBuffer[];
double SignalBuffer[];
double HighesBuffer[];
double LowesBuffer[];
double HighesBuffera[];
double LowesBuffera[];
string ShortName;


//------------------------------------------------------------------
//
//------------------------------------------------------------------

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0, MainBuffer);   SetIndexLabel(0,"Stochastic");
   SetIndexBuffer(1, SignalBuffer); SetIndexLabel(1,"Signal");
   SetIndexBuffer(2, HighesBuffer);
   SetIndexBuffer(3, LowesBuffer);
   SetIndexBuffer(4, HighesBuffera);
   SetIndexBuffer(5, LowesBuffera);
      SetLevelValue(0,Level1);
      SetLevelValue(1,Level2);
   IndicatorShortName("Stochastic ("+(string)KPeriod+","+(string)DPeriod+","+(string)Slowing+")");
   return(0);
}
int deinit()
{
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for(int i = limit; i >= 0 ; i--)
   {
      if (Price==pr_highlow)
         {
            LowesBuffera[i] =Low[i];
            HighesBuffera[i]=High[i];
         }
      else         
         {
            LowesBuffera[i] =iMA(NULL,0,1,0,MODE_SMA,(int)Price,i);
            HighesBuffera[i]=iMA(NULL,0,1,0,MODE_SMA,(int)Price,i);
         }
         LowesBuffer[i] = LowesBuffera[ArrayMinimum(LowesBuffera,KPeriod,i)];
         HighesBuffer[i]= HighesBuffera[ArrayMaximum(HighesBuffera,KPeriod,i)];
      
         //
         //
         //
         //
         //
      
         double sumlow  = 0.0;
         double sumhigh = 0.0;
            for(int k=0;k<Slowing && (i+k)<Bars;k++)
            {
               if (Price==pr_highlow)
                     sumlow  += Close[i+k]       -LowesBuffer[i+k];
               else  sumlow  += LowesBuffera[i+k]-LowesBuffer[i+k];     
               sumhigh += HighesBuffer[i+k]-LowesBuffer[i+k];
            }
            if(sumhigh==0.0) 
                  MainBuffer[i] = 100.0;
            else  MainBuffer[i] = sumlow/sumhigh*100.0;
   }      
   for(int i=0; i<limit; i++) SignalBuffer[i]=iMAOnArray(MainBuffer,0,DPeriod,0,MAMode,i);
   return(0);
}